function [x,y,pol]=extractOsloImagerEventsFromAddr(addr)
%function [x,y,pol]=extractOsloImagerEventsFromAddr(addr)
% extracts retina events from 16 bit addr vector.
%
% addr is vector of n event addresses, 
% returns x,y addresses and spike ON/OFF polarity pol with pol=1 for ON and
% pol=-1 for OFF

persistent xmask ymask xshift yshift polmask
if isempty(xmask),
    xmask = bin2dec ('0000000001111111'); % x are 6 bits (64 cols) ranging from bit 1-7
    ymask = bin2dec ('0111111100000000'); % y are also 6 bits
    xshift=0; % bits to shift x to right
    yshift=8; % bits to shift y to right
    %polmask=1; % polarity bit
end

if nargin==0,
    error('provide addresses as input vector');
end

%mask aer addresses to ON and OFF address-strings
% find spikes in frame window
x=floor(bitand(addr,xmask)/2^xshift);
%x=double(bitshift(bitand(addr,xmask),-xshift)); % x addresses (127- is for flipping)
y=floor(bitand(addr,ymask)/2^yshift);
%y=double(bitshift(bitand(addr,ymask),-yshift)); % y addresses
%pol=1-2*double(bitand(addr,polmask)); % 1 for ON, -1 for OFF
pol=ones(size(x));

% n=min([3,length(addr)]);
% for i=1:n,
%     fprintf('addr=0x%x, x=%x, y=%x\n',double(addr(i)),x(i),y(i));
% end
