/* 
mex source for USB AE Monitor using simple Sevilla USB AE board and SiLabs USBXPress
	this should be built using matlab's lcc included C compiler.
	mex -setup
		and choose lcc compiler
	mex usbaemon.c SiUSBXp.lib
	
 -tobi 30.1.05
 */
 
#include <windows.h>	// include this to define DWORD, etc.
#include "mex.h"
#include "SiUSBXpC.h"	// customized version of SILabs header modified for C from C++

#ifdef __cplusplus		// MS VC should compile this ".c" file with the plain C compiler so this shouldn't be necessary
extern "C" {
#endif

void
mexFunction(int nlhs,mxArray *plhs[],int nrhs,const mxArray *prhs[])
{
    DWORD	numDevices;
    SI_STATUS status;
    char deviceString[256];    
	DWORD deviceNum;
	HANDLE deviceHandle;
	
	mexPrintf("starting usbaemon\n");
	
	status=SI_GetNumDevices (&numDevices);
	if(status!=SI_SUCCESS){
		mexErrMsgTxt("error SI_GetNumDevices");
	}
	if(numDevices==0){
		mexErrMsgTxt("error SI_GetNumDevices no devices");
	}
	mexPrintf("%d devices found\n",numDevices);
	deviceNum=0;
	
	status=SI_GetProductString (deviceNum,deviceString,SI_RETURN_DESCRIPTION);
	if(status!=SI_SUCCESS){
		mexErrMsgTxt("error SI_GetProductString");
	}
	mexPrintf("product string: %s\n",deviceString);
		
	status = SI_Open(0, &deviceHandle);
	if(status!=SI_SUCCESS){
		mexErrMsgTxt("error SI_Open");
	}
	mexPrintf("device handle: %d",deviceHandle);
	
	status = SI_Close(deviceHandle);
	if(status!=SI_SUCCESS){
		mexErrMsgTxt("error SI_Close");
	}
	mexPrintf("device closed");
	
		
//	while(1){
//		status=
//	
//    /* Examine input (right-hand-side) arguments. */
//    mexPrintf("\nThere are %d right-hand-side argument(s).", nrhs);
//    for (i=0; i<nrhs; i++)  {
//	mexPrintf("\n\tInput Arg %i is of type:\t%s ",i,mxGetClassName(prhs[i]));
//    }
//    
//    /* Examine output (left-hand-side) arguments. */
//    mexPrintf("\n\nThere are %d left-hand-side argument(s).\n", nlhs);
//    if (nlhs > nrhs)
//      mexErrMsgTxt("Cannot specify more outputs than inputs.\n");
//    for (i=0; i<nlhs; i++)  {
//	plhs[i]=mxCreateDoubleMatrix(1,1,mxREAL);
//	*mxGetPr(plhs[i])=mxGetNumberOfElements(prhs[i]);
//    }
}


#ifdef __cplusplus
}
#endif
