function [x,y,pol]=extractConvolutionEventsFromAddr(addr)
%function [x,y,pol]=extractRetinaEventsFromAddr(addr)
% extracts retina events from 16 bit addr vector.
%
% addr is vector of n event addresses, 
% returns x,y addresses and spike ON/OFF polarity pol with pol=1 for ON and
% pol=-1 for OFF

persistent xmask ymask xshift yshift polmask polshift
if isempty(xmask),
    xmask = hex2dec ('001f'); % x are 5 bits (32 cols)
    ymask = hex2dec ('1F00'); % y are also 5 bits
    xshift=0; % bits to shift x to right
    yshift=8; % bits to shift y to right
    polmask=hex2dec('0080');; % polarity bit
    polshift=7;
end

if nargin==0,
    error('provide addresses as input vector');
end

%mask aer addresses to ON and OFF address-strings
% find spikes in frame window
x=double(bitshift(bitand(addr,xmask),-xshift)); % x addresses
y=double(bitshift(bitand(addr,ymask),-yshift)); % y addresses
pol=1-2*double(bitshift(bitand(addr,polmask),-polshift)); % 1 for ON, -1 for OFF

% n=min([3,length(addr)]);
% for i=1:n,
%     fprintf('addr=0x%x, x=%x, y=%x\n',double(addr(i)),x(i),y(i));
% end
