% loop and plot events for t days
t=10; % in seconds
fprintf('recording for %g seconds\n',t);
t=t/24/60/60; % days to collect (1st term is seconds)
%clear usbaemon;
alladdr=[];
allts=[];
st=now;
figure(1);
clf
captureCounter=0;
while now-st<t, 
    [addr,ts,overrun]=usbaemon;
    captureCounter=captureCounter+1;
    if overrun, fprintf('overrun occured in capture %d\n',captureCounter); end
    if length(addr)==0, continue, end; % in case of overrun
    subplot(311);
    plot(ts,addr);  % row 2 are times, row 1 are addresses
    xlabel 'Time (us)'; 
    ylabel 'Address'; 
    [x,y,pol]=extractRetinaEventsFromAddr(addr);
    dt=double(ts)-double(ts(1));
    subplot(334);
    plot(dt,x);
    xlabel 'ts'
    ylabel 'x'
    subplot(335);
    plot(dt,y);
    xlabel 'ts'
    ylabel 't'
    subplot(336);
    plot(dt,pol,'o');
    xlabel 'ts'
    ylabel 'pol'
    
    subplot(313);
    plot(diff(double(ts)),'x'); % just plot times to check wrapping
    xlabel 'Time (us)'
    ylabel '{\Delta}t (us)'
    drawnow;
    alladdr=[alladdr,addr];
    allts=[allts,ts];
end
figure(2);
t=double(allts);
dt=diff(t);
hist(dt,300);
xlabel 'interspike intervals'
ylabel 'frequency'
tdt=max(t)-min(t);
dts=tdt/1e6;
nevents=length(alladdr);
mindt=min(dt); maxdt=max(dt);
fprintf('%d events, min t=%d us, max t=%d us, delta t=%g us\n',nevents,min(t), max(t),tdt);
fprintf('min dt=%d us, max dt=%d us\n',mindt,maxdt);
fprintf('%d events in %g seconds=%.1f eps\n',nevents, tdt/1e6,nevents/tdt*1e6);
disp 'dt=0'
find(dt==0)
figure(3);
hist(log10(dt(find(dt>0))),100);
xlabel 'log10 intervals (us)'
ylabel 'freq'
