function [x,y,pol]=extractRetinaEventsFromAddr(addr)
%function [x,y,pol]=extractRetinaEventsFromAddr(addr)
% extracts retina events from 16 bit addr vector.
%
% addr is vector of n event addresses, 
% returns x,y addresses and spike ON/OFF polarity pol with pol=1 for ON and
% pol=-1 for OFF

persistent xmask ymask xshift yshift polmask
if isempty(xmask),
    xmask = hex2dec ('7E'); % x are 6 bits (64 cols) ranging from bit 1-7
    ymask = hex2dec ('3F00'); % y are also 6 bits
    xshift=1; % bits to shift x to right
    yshift=8; % bits to shift y to right
    polmask=1; % polarity bit
end

if nargin==0,
    error('provide addresses as input vector');
end

%mask aer addresses to ON and OFF address-strings
% find spikes in frame window
x=63-double(bitshift(bitand(addr,xmask),-xshift)); % x addresses
y=double(bitshift(bitand(addr,ymask),-yshift)); % y addresses
pol=1-2*double(bitand(addr,polmask)); % 1 for ON, -1 for OFF

% n=min([3,length(addr)]);
% for i=1:n,
%     fprintf('addr=0x%x, x=%x, y=%x\n',double(addr(i)),x(i),y(i));
% end
