function o=getEventExtractor(chip)
%function o=getEventExtractor(chip)
% returns java class event extractor for a particular chip, e.g. tmpdiff64,
% tmpdiff128, doubleLine
try
    if strcmp(chip,'tmpdiff64'),
        o=ch.unizh.ini.caviar.retina.Tmpdiff64EventExtractor;  % can't serialize a java object
    elseif strcmp(chip,'tmpdiff128'),
        o=ch.unizh.ini.caviar.retina.Tmpdiff128EventExtractor2;  % can't serialize a java object
    elseif strcmp(chip,'doubleLine'),
        o=ch.unizh.ini.caviar.retina.TestchipARCSLineSensorEventExtractor;  % can't serialize a java object
    else
        error(['no event extractor defined for chip ' chip]);
    end
catch
    error('java class for event extraction not found, you need to add path to usb2aemon.jar to you java classpath');
end