function playSpikeSound(pol)
%function playSpikeSound(pol)
% plays a spike sound. pol is an optional channel arg that may not be
% enabled because it causes problems.
%
% NOTE this method, if called too often, can crash matlab 7.01!!

persistent spikeSoundSamples spikeSoundSamplesOn spikeSoundSamplesOff
if isempty(spikeSoundSamples),
    nSamps=200;
    x=linspace(0,pi,nSamps);
    y=sin(x).^4;
    z=gradient(y,x);
    z=z/max(z);
    spikeSoundSamples=z;
    zz=zeros(nSamps,1);
    spikeSoundSamplesOn=[z',zz];
    spikeSoundSamplesOff=[zz,z'];
end
if nargin==0,
    sound(spikeSoundSamples,44100,8);
elseif pol==1,
    sound(spikeSoundSamplesOn,44100,8);
else
    sound(spikeSoundSamplesOff,44100,8);
end
return